#	$LAAS: config.mk.in,v 1.6 2004/07/22 08:27:38 mallet Exp $

#
# Copyright (c) 2000-2004 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# --- RTAI-specific configuration ---------------------------------------

CPPFLAGS+=	-D__RTAI__

MODDIR=		modules
MOD=		$(MODDIR)/lib$(BASENAME).o

MOD_CPPFLAGS+=	-I$(KERNEL_INC) -D__KERNEL__ -DMODULE

ifeq (powerpc,$(host_cpu))
MOD_CFLAGS+=	-fsigned-char -ffixed-r2 -mmultiple -mstring
endif

MODOBJS=$(MODSRCS:%.c=$(MODDIR)/%.lo)

# how to build a module
all-os:	$(MODDIR) $(MOD)

# relocatable object
$(MOD): $(MODOBJS)
	$(LTLD) -o $@ $(MODOBJS)

$(MODDIR)/%.lo: %.c
	$(LTCC) -prefer-non-pic -c $(CFLAGS) $(MOD_CFLAGS) \
		$(CPPFLAGS) $(MOD_CPPFLAGS) -o $@ $<

# object file directory
$(MODDIR):
	mkdir -p $@

# install
install:: all-os
	$(LTINSTALL) $(MOD) $(libdir)/$(MOD)

clean::
	$(LIBTOOL) --mode=clean rm -f $(MODOBJS) $(MOD)

# module dependencies
depend $(MODDIR)/DEPENDANCES:: $(MODDIR)
depend $(MODDIR)/DEPENDANCES:: $(MODSRCS)
	$(MKDEP) -c$(CC) -o$(MODDIR)/DEPENDANCES -d$(MODDIR) -t.lo \
		$(CPPFLAGS) $(MOD_CPPFLAGS) $?

ifneq (,$(MODSRCS))
ifneq (distclean,$(MAKECMDGOALS))
include $(MODDIR)/DEPENDANCES
endif
endif
